/*---------------------------------------------------------------------------

    panel.cpp
    
    Copyright (c) 2008 by M. Pernter (iw3aut@yahoo.it)
    
    panel.cpp defines the functions used by the contol panel for interfacing
    between WinRAD and the PMSDR Software Defined Radio using the PIC18F4550 USB
    chip and the CY22394 clock generator.


    GPL

    This file is part of ExtIO_PMSDR.dll.

    ExtIO_PMSDR.dll is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as published
    by the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    ExtIO_ElektorSDR.dll is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

  ---------------------------------------------------------------------------*/

//---------------------------------------------------------------------------

#include <vcl.h>
#include <fstream>
#include "main.h"
#include "codeDeviceManager.h"
#include "about.h"
#include "pmlog.h"
using namespace std;
#pragma hdrstop

#include "Panel.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{

}

//---------------------------------------------------------------------------

void __fastcall TForm1::InputSelectClick(TObject *Sender)
{
  //setInput((int)InputSelect->ItemIndex);
  return;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::IF_GainClick(TObject *Sender)
{

  return;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::AboutButtonClick(TObject *Sender)
{
  Form2->Visible = true;
  Form2->BringToFront();

  return;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  Action = caHide;
  return;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::HideForm(TObject *Sender)
{
  Visible = false;
  return;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SHowForm(TObject *Sender)
{
  Visible = true;

  return;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormCreate(TObject *Sender)
{
  TEdit_Bias->Text= AnsiString().sprintf ("%1.2f V",(float)ScrollBar_QSDBias->Position *5/1024);
  ifstream infile("pmsdr.bin",ios::binary);
  if (!infile) {
    infile.close();
    Memo1->Lines->Add("PMSDR.BIN not found");
    //postdiv_array[1]=1;
    }
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
  deviceManager.CloseDevice();
  deviceManager.StopExecution();
  //return;
}



void __fastcall TForm1::ScrollBar_QSDBiasChange(TObject *Sender)
{
   unsigned long x;
   //unsigned int ret=5;
     x = ScrollBar_QSDBias->Position;
     deviceManager.SetQSDBias(x,TCheck_Mute->Checked,IF_Gain->ItemIndex,0,Filterselector->ItemIndex);
     //deviceManager.SetLOfreq((unsigned long)DLL_DEF_FREQ);
     TEdit_Bias->Text= AnsiString().sprintf ("%1.2f V",((float)x *5/1024));
     Memo1->Lines->Add(AnsiString().sprintf ("Set IF_Gain= %d dB",10*(int)(IF_Gain->ItemIndex+1)));
}

//---------------------------------------------------------------------------



void __fastcall TForm1::PMLOGButtonClick(TObject *Sender)
{ 
  if (FormPMLog == NULL)
        FormPMLog = new TFormPMLog(NULL);
  else FormPMLog->Visible = true;
  FormPMLog->BringToFront();
  return;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CreatePostdivFile()
{
  ifstream infile("pmsdr.bin",ios::binary);
  if (!infile) {
    infile.close();
    Memo1->Lines->Add("PMSDR.BIN not found");
    return;//postdiv_array[1]=1;
    }
    
}



//---------------------------------------------------------------------------


void __fastcall TForm1::F1_1Change(TObject *Sender)
{
 if (F1_1->Value >= F1_2->Value) F1_2->Value = F1_1->Value+1;
 if (F2_1->Value >= F2_2->Value) F2_2->Value = F2_1->Value+1;
 if (F3_1->Value >= F3_2->Value) F3_2->Value = F3_1->Value+1;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button_SaveFilterClick(TObject *Sender)
{
      unsigned short reg[6];

      if (mrNo == MessageDlg("Overwrite the filter data. IF YOU SURE?\nI dati dei filtri stanno per essere modificati. SEI SICURO?\nDie Filterdaten werden ueberschrieben. BIST DU SICHER?",
               mtWarning, TMsgDlgButtons() << mbOK<<mbNo, 0))
          return;

      reg[0]= (unsigned short)F1_1->Value;
      reg[1]= (unsigned short)F1_2->Value;
      reg[2]= (unsigned short)F2_1->Value;
      reg[3]= (unsigned short)F2_2->Value;
      reg[4]= (unsigned short)F3_1->Value;
      reg[5]= (unsigned short)F3_2->Value;

      deviceManager.SetFilter(reg, 7);
}
//---------------------------------------------------------------------------

