/*---------------------------------------------------------------------------

    panel.h
    
    Copyright (c) 2007 by G.J. Kruizinga (gjk4all@gmail.com)
    
    panel.h defines the object of the control panel for interfacing between
    WinRAD and the Elektor Software Defined Radio (Elektor may 2007) using
    the FT-232R USB chip and the CY27EE16-8 clock generator.
    
    
    GPL
    
    This file is part of ExtIO_ElektorSDR.dll.

    ExtIO_ElektorSDR.dll is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as published
    by the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    ExtIO_ElektorSDR.dll is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

  ---------------------------------------------------------------------------*/

//---------------------------------------------------------------------------

#ifndef PanelH
#define PanelH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include "CSPIN.h"
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TRadioGroup *IF_Gain;
        TButton *AboutButton;
        TLabel *Label1;
        TEdit *TEdit_freq_ref;
        TComboBox *cmbDEMOCommunicationChannel;
        TEdit *TEdit_info;
        TEdit *TEdit_lo_freq;
        TGroupBox *DDS_PLL;
        TEdit *TEdit_pll_postdivider;
        TScrollBar *ScrollBar_QSDBias;
        TLabel *Label2;
        TLabel *Label4;
        TEdit *TEdit_clka_freq;
        TLabel *Label5;
        TEdit *TEdit_Bias;
        TLabel *Label6;
        TGroupBox *QSD_Mixer;
        TMemo *Memo1;
        TButton *PMLOGButton;
        TCheckBox *TCheck_Mute;
        TGroupBox *Si570;
        TLabel *Label8;
        TLabel *Label9;
        TLabel *Label11;
        TEdit *TEdit_pll_HS_DIV_N;
        TEdit *TEdit_pll_RFREQ;
        TEdit *TEdit_freq_fxtal;
        TEdit *TEdit_pll_DCO;
        TEdit *TEdit_4xfreq;
        TLabel *Label13;
        TEdit *MHz;
        TRadioGroup *Filterselector;
        TCheckBox *TCheck_AutoFilter;
        TCSpinEdit *F1_1;
        TGroupBox *Filter;
        TCSpinEdit *F1_2;
        TCSpinEdit *F2_1;
        TCSpinEdit *F2_2;
        TCSpinEdit *F3_1;
        TCSpinEdit *F3_2;
        TLabel *Label3;
        TLabel *Label10;
        TLabel *Label12;
        TButton *Button_SaveFilter;
        void __fastcall InputSelectClick(TObject *Sender);
        void __fastcall IF_GainClick(TObject *Sender);
        void __fastcall AboutButtonClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall ScrollBar_QSDBiasChange(TObject *Sender);
        void __fastcall PMLOGButtonClick(TObject *Sender);
        void __fastcall CreatePostdivFile();
        void __fastcall F1_1Change(TObject *Sender);
        void __fastcall Button_SaveFilterClick(TObject *Sender);
        
private:	// User declarations

public:		// User declarations
        //DeviceManager  deviceManager;
       
             __fastcall TForm1(TComponent* Owner);
        void __fastcall TForm1::HideForm(TObject *Sender);
        void __fastcall TForm1::SHowForm(TObject *Sender);
        //unsigned char postdiv_array[300000];
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
extern DeviceManager  deviceManager;
//---------------------------------------------------------------------------
#endif
